indexing
  description: "A record of one operation on a bank account"
  author: "Gunnar Gotshalks"
  date: "$2004 January 31$"
  revision: "$1.0.0$"

class TRANSACTION

create make

--========================
feature{NONE} --creation
  
make(the_account:SAVINGS_ACCOUNT ; transaction_type : INTEGER ;
     transaction_amount: REAL ; transaction_date: DATE) is
  -- new transaction
  require
    account_exists: the_account /= Void
    date_exists: transaction_date /= Void
  do
    account := the_account
    amount := transaction_amount
    date := transaction_date
    type := transaction_type
    create bc
  ensure
    proper_data:
      account = the_account and date = transaction_date and
      amount = transaction_amount and type = transaction_type
    proper_type: bc.trans_create <= type and type <= bc.trans_withdraw
      
  end

--========================
feature -- Data access

  account: SAVINGS_ACCOUNT  -- the account for the 
  amount: REAL              -- the amount of the transaction for a depost or withdrawal
  date: DATE
  type : INTEGER			-- the transaction type -- one of the following

--========================
feature {NONE} -- Implementation data

bc : BANK_CONSTANTS
  
end -- class TRANSACTION

