indexing
  description: "Tests for SAVINGS_ACCOUNT in bank"
  author: "Gunnar Gotshalks"
  date: "$2004 January 30$"
  revision: "$1.0.0$"
  
class TEST_TRANSACTION
  inherit ES_TEST
  
create  make

--========================  
feature {NONE} -- Initialization
make is
    -- Run tests
  do
    create bc
    all_violation_cases
    all_boolean_cases
  end  

bc : BANK_CONSTANTS
--========================
feature -- Violation

all_violation_cases is
  -- Gather all violation cases together to simplify turning off while
  -- working on the boolean cases
  do
    add_violation_case (agent account_exists)
    add_violation_case (agent date_exists)
 end
  
account_exists is
  local
    the_account : SAVINGS_ACCOUNT
    the_date : DATE
    the_transaction :TRANSACTION
   do
    comment("Precondition account exists")
    create the_transaction.make(the_account, 0, bc.trans_open,
                                the_date)
  end
  
date_exists is
  local
    the_account : SAVINGS_ACCOUNT
    the_date : DATE
    the_transaction :TRANSACTION
   do
    comment("Precondition date exists")
    create the_account.make
    create the_transaction.make(the_account, 0, bc.trans_open, the_date)
  end
	
--========================
feature -- Boolean  

all_boolean_cases is
  -- Gather all boolean cases as a unit.
  do
    add_boolean_case (agent proper_data)
    add_boolean_case (agent proper_type)
 end

proper_data: BOOLEAN is
  local
    the_account : SAVINGS_ACCOUNT
    the_amount : REAL
    the_date : DATE
    the_transaction :TRANSACTION
  do
    comment("Is the transaction data correctly stored?")
    create the_account.make
    create the_date.make_now
    the_amount := 123
    create the_transaction.make(the_account, bc.trans_deposit, the_amount, the_date)
    Result := the_transaction.account = the_account and
              the_transaction.amount = the_amount and
              the_transaction.date = the_date
  end

proper_type: BOOLEAN is
  local
    the_account : SAVINGS_ACCOUNT
    the_amount : REAL
    the_date : DATE
    the_transaction :TRANSACTION
  do
    comment("Is the transaction type correctly stored?")
    create the_account.make
    create the_date.make_now
    the_amount := 123
    create the_transaction.make(the_account, bc.trans_deposit, the_amount, the_date)
    Result := the_transaction.type = bc.trans_deposit
  end
  
end -- class TEST_TRANSACTION
