indexing
  description: "Defines common data and contants used by the bank"
  author: "Gunnar Gotshalks"
  date: "2004 January 31"
  revised: "2004 February 6" 
  version: "1.0"

class BANK_COMMON_DATA inherit SINGLETON

--========================
feature -- Constants

  -- Transaction types as consecutive integers
  
trans_create, trans_open, trans_close,
trans_deposit, trans_withdraw : INTEGER is unique

--========================
feature {SAVINGS_ACCOUNT} -- Savings account
  -- Features that are common to all savings accounts

last_account_number: INTEGER  -- each account has a unique accout number

generate_next_account_number is
    -- to get new account mumber
  require true
  do
    last_account_number := last_account_number + 1
  ensure
    increment_account_no:  last_account_number = old last_account_number + 1
    account_number_positive: last_account_number > 0
  end

--========================
feature {NONE} -- Singleton

	frozen the_singleton : SINGLETON is
		-- The unique instance of this class
	once
		Result := Current
	end
 
end -- class BANK_COMMON_DATA
