indexing
  description: "A record of one operation on a bank account"
  author: "Gunnar Gotshalks"
  date: "$2004 January 31$"
  revision: "$1.0.0$"

class TRANSACTION

create make

--========================
feature{NONE} --creation
  
make(the_account:SAVINGS_ACCOUNT ; transaction_type : INTEGER ;
     transaction_amount: REAL ; transaction_date: DATE) is
  -- new transaction
  require
    account_exists: the_account /= Void
    date_exists: transaction_date /= Void
  do
    account := the_account
    amount := transaction_amount
    date := transaction_date
    type := transaction_type
  ensure
    proper_data:
      account = the_account and date = transaction_date and
      amount = transaction_amount and type = transaction_type
    proper_type: bcd.trans_create <= type and type <= bcd.trans_withdraw
      
  end

--========================
feature -- Data access

  account: SAVINGS_ACCOUNT  -- the account on which the transaction is done
  amount: REAL              -- the amount of the transaction for a depost or withdrawal
  date: DATE                -- the date & time at which the transaction was done
  type : INTEGER			-- the transaction type

--========================
feature {NONE} -- Implementation data

bcd : BANK_COMMON_DATA is
    -- access to common bank data
  local
	da: BANK_DATA_ACCESS
  once
	da := create{BANK_DATA_ACCESS}
	Result := da.data
  end
  
end -- class TRANSACTION

